package com.liang.controller;

import com.liang.common.annotation.LogAround;
import com.liang.entity.BasePstasortcode;
import com.liang.service.BasePstasortcodeService;
import io.swagger.annotations.ApiOperation;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * (BasePstasortcode)表控制层
 *
 * @author makejava
 * @since 2023-03-04 13:44:00
 */
@Controller
@RequestMapping("basePstasortcode")
public class BasePstasortcodeController {
    /**
     * 服务对象
     */
    @Resource
    private BasePstasortcodeService basePstasortcodeService;

    /**
     * 分页查询
     *
     * @param basePstasortcode 筛选条件
     * @param pageRequest      分页对象
     * @return 查询结果
     */
    @GetMapping
    public ResponseEntity<Page<BasePstasortcode>> queryByPage(BasePstasortcode basePstasortcode, PageRequest pageRequest) {
        return ResponseEntity.ok(this.basePstasortcodeService.queryByPage(basePstasortcode, pageRequest));
    }

    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    @GetMapping("{id}")
    public ResponseEntity<BasePstasortcode> queryById(@PathVariable("id") Integer id) {
        return ResponseEntity.ok(this.basePstasortcodeService.queryById(id));
    }

    /**
     * 新增数据
     *
     * @param basePstasortcode 实体
     * @return 新增结果
     */
    @PostMapping
    public ResponseEntity<BasePstasortcode> add(BasePstasortcode basePstasortcode) {
        return ResponseEntity.ok(this.basePstasortcodeService.insert(basePstasortcode));
    }

    /**
     * 编辑数据
     *
     * @param basePstasortcode 实体
     * @return 编辑结果
     */
    @PutMapping
    public ResponseEntity<BasePstasortcode> edit(BasePstasortcode basePstasortcode) {
        return ResponseEntity.ok(this.basePstasortcodeService.update(basePstasortcode));
    }

    /**
     * 删除数据
     *
     * @param id 主键
     * @return 删除是否成功
     */
    @DeleteMapping
    public ResponseEntity<Boolean> deleteById(Integer id) {
        return ResponseEntity.ok(this.basePstasortcodeService.deleteById(id));
    }

    @ApiOperation(value = "页面初始化", notes = "页面初始化")
    @RequestMapping(value = "/init", method = RequestMethod.GET)
    public String init() {
        return "basepstasortcode/list";
    }

    @LogAround("数据分页查询")
    @ApiOperation(value = "数据分页查询", notes = "数据分页查询")
    @ResponseBody
    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public Object list() {

        List<BasePstasortcode> list = basePstasortcodeService.queryAll();

        Map<String, Object> resultMap = new HashMap<>();
        resultMap.put("code", 0);
        resultMap.put("msg", "");
        resultMap.put("count", list.size());
        resultMap.put("data", list);

        return resultMap;
    }
}

